//+------------------------------------------------------------------+
#property copyright "   YOU are using an ILLEGAL COPY of MY software and you are now liable to PROSECUTION!  Eirik Karlsen 2009. eikarlse@online.no"
//+------------------------------------------------------------------+
//
#include <WinUser32.mqh>
#include <stderror.mqh>
#include <stdlib.mqh>
//---------- External settings ------------------------
extern   int      BalanceCutOff = 0;//Stop trading if Balance drops below this level
extern   double   Lots = 0.0;//Fixed lot size. Use 0.0 for AutoLot
extern   double   MaxLots = 50.0;//50
extern   int      RiskPercent = 1;//This is risk percent PR ORDER !!
extern   string   Sep0 = "-/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\-";
extern   double   TakeProfit = 6.0;//60
extern   double   StopLoss = 50.0;//500
extern   double   MaxSpread = 60.0;
extern   double   Slippage = 2.0;//10
extern   int      OrderRetry = 5;//In case of requote
extern   string   Sep1 = "-/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\-";
extern   int      MaxOrdersDir = 4;//Max open orders in each direction
extern   string   Sep2 = "-/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\-";
extern   int      Samples = 3;//3
extern   int      SamplePeriod = 5;
extern   int      MagicNumber = 1234567;
extern   bool     AutoMagic = TRUE;//Generate Magic Number based on Symbol and Long/Short params
extern   bool     TradeLong  = TRUE; 
extern   bool     TradeShort = TRUE; 
extern   bool     ShowInfo = TRUE;//Info in UL corner, turn OFF during testing !
extern   string   Sep3 = "-/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\-";
extern   int      HourStart = 23.0;//23
extern   int      HourStop = 2.0;//2
extern   int      GMToffset = 0;// Valid range is 0 to 23 !
extern   bool     TradeMonday    = TRUE;
extern   bool     TradeTuesday   = TRUE;
extern   bool     TradeWednesday = TRUE;
extern   bool     TradeThursday  = TRUE;
extern   bool     TradeFriday    = FALSE;
extern   bool     TradeSunday    = TRUE;
//---------------------- Copyright Notice ----------------------------
extern   string   Sep4 = "-/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\-";
extern   string   L01 = "You are in possession of STOLEN";
extern   string   L02 = "proprietary software of significant economic";
extern   string   L03 = "value, DELETE IT IMMEDIATELY!";
extern   string   L04 = "This Expert Advisor is developed by";
extern   string   L05 = "Eirik Karlsen (eikarlse@online.no) who has";
extern   string   L06 = "all intellectual property rights to this";
extern   string   L07 = "software. I will not allow any form of lending,";
extern   string   L08 = "leasing sale or any other form of public use";
extern   string   L09 = "of this software, it is for my personal use";
extern   string   L10 = "only. YOU are using an ILLEGAL COPY of";
extern   string   L11 = "MY software and...";               
extern   string   L12 = "<<YOU are now liable to PROSECUTION>>";
extern   string   L13 = "Copyright Eirik Karlsen,   eikarlse@online.no";
 //
//-----------------------------------------------------



bool     OneShot = FALSE;//Send ShutDown messages ony once
double   SL, TP;//final stops
bool     InfoSDmessage = FALSE;//Used by InfoField()
double   PriceSell, PriceBuy;//
double   LotsVolume;//Final order size
int      ObjCnt;//Vline counter
int      SymbolPointMul;//Symbol Point multiplier
int      StartTime, StopTime;//Actual trading time, GMT corrected
//-------
int      MagicNumber_Old;
bool     AutoMagic_Old;
bool     TradeLong_Old;
bool     TradeShort_Old;
//-------
//-------------
int init() {
   OneShot = FALSE;//Re-enable EA after a safety shutdown
   AutoMagic();//Done here for immediate update of InfoField
   CalcSymbolDigits();//This one is needed here because of InfoField !
   InfoField();//Put some key data in the UL corner when EA is attached to the chart
return (0);
}
//-------------

//-------------
int deinit() {
DeleteInfoBackground();//
return (0);
}
//-------------

//-----------------------------------------------------------------------------------------------------------
int start() {
   //if( !Authenticate() ) return(0);//Check if EA is licensed!
   //if ( SaveAccount() ) return(0);//Stop trading if account balance drops below limit

   MagicWarning();//Display a warning in case MagicNumber is changed
   AutoMagic();//Generate Magic Number based on Symbol and Long/Short params
   CalcSymbolDigits();//Disregarding broker digits, we ONLY consider actual Symbol digits
   CalcPriceLimits();//Determine the Buy and Sell price limits
   CheckStops();//validate stops   
   InfoField();//Put some key data in the UL corner 
   PossiblyOpenNewOrder();//Open a new order if all conditions are met
return (0);
}
//-----------------------------------------------------------------------------------------------------------




//----------------------------
//------ FUNCTIONS -----------
//----------------------------

//---------- PossiblyOpenNewOrder ------------------------
void PossiblyOpenNewOrder() {
   if ( !GeneralConditionsOk() ) return(0);
      LotsVolume = CalcLotsVolume();//Size to send, limited to MaxLots
      if (SignalSell())
         {
         OpenSell();//Send a new Sell order!
         }
      if (SignalBuy())
         {
         OpenBuy();//Send a new Buy order!
         }
return (0);
}
//-----------------------------------------------------




//---------- OpenBuy ---------------------------------
void OpenBuy() {
   double   StopLossToSend = (Ask - SL * Point*SymbolPointMul);
   double   TakeProfitToSend = (PriceBuy + TP * Point*SymbolPointMul);   
   for(int i=0; i < OrderRetry; i++) {//Try to force the order trough, despite requotes...
      CalcPriceLimits();//Get current prices and signal
      if( !SignalBuy()) { //If Buy signal has gone, give up on this entry...
         DrawVline(White, Time[0]);//Mark spot of missed trade
         return(0); }//         
      //Prices and signal in general are still good, so we give it another try:
      int Ticket = OrderSend(Symbol(), OP_BUY, LotsVolume, Ask, Slippage *SymbolPointMul, StopLossToSend, TakeProfitToSend, "Enigma", MagicNumber, 0, Blue);//Send order
      Sleep(3000);//Wait for server reply
      if( Ticket > -1 ) return(0);//The order was accepted!
      }//Go around and try again...
return (0);
}
//-----------------------------------------------------

//---------- OpenSell ---------------------------------
void OpenSell() {
   double   StopLossToSend = (Bid + SL * Point*SymbolPointMul);
   double   TakeProfitToSend = (PriceSell - TP * Point*SymbolPointMul);   
   for(int i=0; i < OrderRetry; i++) {//Try to force the order trough, despite requotes...
      CalcPriceLimits();//Get current prices and signal
      if( !SignalSell()) { //If Sell signal has gone, give up on this entry...
         DrawVline(White, Time[0]);//Mark spot of missed trade
         return(0); }//         
      //Prices and signal in general are still good, so we give it another try:      
      int Ticket = OrderSend(Symbol(), OP_SELL, LotsVolume, Bid, Slippage *SymbolPointMul, StopLossToSend, TakeProfitToSend, "Enigma", MagicNumber, 0, Red);//Send order   
      Sleep(3000);//Wait for server reply
      if( Ticket > -1 ) return(0);//The order was accepted!
      }//Go around and try again...     
return (0);
}
//-----------------------------------------------------

//---------------- CalcPriceLimits --------------------
void CalcPriceLimits() {//In order to be of interest the price has to break beyond these limits
   RefreshRates();
   PriceBuy  = Low[iLowest(NULL, SamplePeriod, MODE_LOW, Samples, 1)];
   PriceBuy  = PriceBuy + (0);
   PriceSell = High[iHighest(NULL, SamplePeriod, MODE_HIGH, Samples, 1)];
   PriceSell = PriceSell + (MarketInfo(Symbol(), MODE_SPREAD)*Point);
return (0);
}
//-----------------------------------------------------

//---------------- SignalBuy --------------------------
bool SignalBuy() {
   if( !TradeLong) return(FALSE);//Buying was disabled
   int   BuyOrders = 0;//Counter. Only buy if there is a free Buy slot...
   for(int pos=0; pos < OrdersTotal(); pos++) {
      if(OrderSelect(pos,SELECT_BY_POS)==false) continue;//All done, or none found      
         if( (OrderMagicNumber() == MagicNumber) && (OrderSymbol() == Symbol()) && (OrderType() == OP_BUY)) {
            BuyOrders++; } }//Found one of OUR Long orders...      
   if( BuyOrders >= MaxOrdersDir ) return(FALSE);//Have reached max number of Buy orders
   if ( Ask <= PriceBuy ) return(TRUE);//Indication: BUY at PriceBuy
return (FALSE);
}
//-----------------------------------------------------

//---------------- SignalSell -------------------------
bool SignalSell() {
   if( !TradeShort) return(FALSE);//Selling was disabled
   int   SellOrders = 0;//Counter. Only sell if there is a free Sell slot...
   for(int pos=0; pos < OrdersTotal(); pos++) {
      if(OrderSelect(pos,SELECT_BY_POS)==false) continue;//All done, or none found      
         if( (OrderMagicNumber() == MagicNumber) && (OrderSymbol() == Symbol()) && (OrderType() == OP_SELL)) {
            SellOrders++; } }//Found one of OUR Short orders...      
   if( SellOrders >= MaxOrdersDir ) return(FALSE);//Have reached max number of Sell orders
   if ( Bid >= PriceSell ) return(TRUE);//Indication: SELL at PriceSell
return (FALSE);
}
//-----------------------------------------------------

//---------------- GeneralConditionsOk ----------------
bool GeneralConditionsOk() {//Common to both Buy and Sell
   if ( SaveAccount() ) return(FALSE);//Stop trading if account balance drops below limit
   if ( TradingDay() && TradingTime() ) {
      if ( (MarketInfo(Symbol(), MODE_SPREAD)/SymbolPointMul) <= MaxSpread ) {
         return(TRUE);//Time and spread ok for trading
         }
      }
return (FALSE);
}
//-----------------------------------------------------

//---------------- CheckStops -------------------------
double CheckStops() {
   double StopLevel = MarketInfo(Symbol(), MODE_STOPLEVEL)/SymbolPointMul;
   double Spread    = MarketInfo(Symbol(), MODE_SPREAD)/SymbolPointMul;   
   if (TakeProfit <= StopLevel) TP = StopLevel;
   else TP = TakeProfit;    
   if (StopLoss <= StopLevel) SL = StopLevel + Spread;//Closest possible SL
   else SL = StopLoss;
return (0);
}
//-----------------------------------------------------

//---------------- TradingTime ------------------------
bool TradingTime() {
   if(GMToffset >= 24) GMToffset = 0;//Valid Offset range is from 0 to 23
   StartTime  = HourStart + GMToffset; 
   if(StartTime > 23) StartTime =HourStart + GMToffset - 24;   
   StopTime  = HourStop + GMToffset; 
   if(StopTime > 23) StopTime = 0;   
   //Comment( "GMT: ",GMToffset, "           Start: ",StartTime , "          Stop: ",StopTime);
   if ( (StartTime < StopTime)  && (TimeHour(TimeCurrent()) < StartTime)  || (TimeHour(TimeCurrent()) >= StopTime) ) return (FALSE);
   if ( (StartTime > StopTime)  && (TimeHour(TimeCurrent()) < StartTime)  && (TimeHour(TimeCurrent()) >= StopTime) ) return (FALSE);
   if (StopTime  == 0.0) StopTime  = 24;
   if (Hour() == StopTime  - 1.0 && Minute() >= 59) return (FALSE);
return (TRUE);
}
//-----------------------------------------------------

//---------------- TradingDay -------------------------
bool TradingDay() {
   if( (DayOfWeek() == 1) && TradeMonday )      return(TRUE);//
   if( (DayOfWeek() == 2) && TradeTuesday )     return(TRUE);//
   if( (DayOfWeek() == 3) && TradeWednesday )   return(TRUE);//
   if( (DayOfWeek() == 4) && TradeThursday )    return(TRUE);//
   if( (DayOfWeek() == 5) && TradeFriday )      return(TRUE);//
   if( (DayOfWeek() == 0) && TradeSunday )      return(TRUE);//
return (FALSE);
}
//-----------------------------------------------------



//---------- NormalizeLot -----------------------------
double NormalizeLot(double Lots) {
   double NormalizedLot;//The final LotSize, bounded by broker's specs
   double InverseLotStep;
   double LotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
   double MinLot  = MarketInfo(Symbol(), MODE_MINLOT);
   double MaxLot  = MarketInfo(Symbol(), MODE_MAXLOT);
   if (MinLot  == 0.0) MinLot = 0.1;//In case MarketInfo returns no info
   if (MaxLot  == 0.0) MaxLot = 5;  //In case MarketInfo returns no info
   if (LotStep == 0.0) InverseLotStep = 1 / MinLot;//In case MarketInfo returns no info
      else InverseLotStep = 1 / LotStep;   
   NormalizedLot = MathFloor(Lots * InverseLotStep) / InverseLotStep;   
   if (NormalizedLot < MinLot) NormalizedLot = MinLot;//Broker's absolute minimum Lot
   if (NormalizedLot > MaxLot) NormalizedLot = MaxLot;//Broker's absolute maximum Lot
return (NormalizedLot);
}
//-----------------------------------------------------

//---------- CalcLotsVolume ---------------------------
double CalcLotsVolume() {//The bool switches Raw lots, and Max-limited lots
   double SendLots;//The actual Lotsize that will be sent with the order
   double MaxLot;//Broker's Maximum permitted amount of a lot.
   double MinLot;//Broker's Minimum permitted amount of a lot.
   double LotStep;//Broker's Step for changing lots, e.g 0.01.
   double SpreadPoints = MarketInfo(Symbol(),MODE_SPREAD);
      MaxLot = MarketInfo(Symbol(), MODE_MAXLOT);
      MinLot = MarketInfo(Symbol(), MODE_MINLOT);
      LotStep = MarketInfo(Symbol(), MODE_LOTSTEP);   
   
   //double PipsAtRisk = SL+50;
   if (Lots > 0.0) SendLots = NormalizeLot(Lots);//The manual LotSize, bounded by broker's specs
      else {//Calculate AutoLot:

      double DollarsToRisk = (RiskPercent / 100.0) * AccountFreeMargin();
      SendLots = (DollarsToRisk / (SL+SpreadPoints)/SymbolPointMul) / MarketInfo(Symbol(),MODE_TICKVALUE);
      }
      
      //Denne er visst litt uferdig! .....
      
      
//---------      
   if (SendLots < MinLot) SendLots = MinLot;//Never exceed Broker's absolute minimum Lot
   if (SendLots > MaxLot) SendLots = MaxLot;//Never exceed Broker's absolute maximum Lot  
   SendLots = NormalizeDouble(SendLots/LotStep, 0) * LotStep;//Normalize lot according to broker specs   
return (SendLots);
}
//-----------------------------------------------------



//---------------- CalcSymbolDigits -------------------
void  CalcSymbolDigits() {
//Disregarding broker digits, we ONLY consider actual Symbol digits
//All pip values are entered as decimal pips, 4-digit broker style..
//E.g: 20.5 (20.5 pips) This goes for 2,3,5 digit symbols for both
//4-digit and 5-digit brokers. The decimal denotes true pip for
//5-digit brokers only. For 4-digit brokers the decimal should be
//set to "0".
   SymbolPointMul=1;
   if(Digits==2) SymbolPointMul=1;
   if(Digits==3) SymbolPointMul=10;
   if(Digits==4) SymbolPointMul=1;
   if(Digits==5) SymbolPointMul=10;
return (0);
}
//-----------------------------------------------------

//---------------- CapitalAtRisk ----------------------
double CapitalAtRisk() {
   //Capital At Risk (in $ ) for a given order = Lots * (StopLoss+spread) * Pipvalue
   //search through our open orders and sum up:
   double   CAR = 0;
   double   SLpips;//Selected order's SL level in pips, incl spread
   double   Spread = MarketInfo(Symbol(), MODE_SPREAD);//True pips
   for(int pos=0; pos < OrdersTotal(); pos++) {
      if(OrderSelect(pos,SELECT_BY_POS)==false) continue;//All done, or none found      
         if( (OrderMagicNumber() == MagicNumber) && (OrderSymbol() == Symbol())) {
            SLpips = (MathAbs(OrderOpenPrice() - OrderStopLoss()) /(Point * SymbolPointMul)) + Spread;                        
            CAR = CAR + OrderLots() * SLpips * MarketInfo(Symbol(),MODE_TICKVALUE);
            }
         }     
return (CAR);
}
//-----------------------------------------------------

//---------------- InfoField --------------------------
void  InfoField() {
   if( !ShowInfo) {//Info was turned off to speed up testing
      Comment("");//Clear all info
      return(0);}
   TradingTime();//Need to call it here to get valid time data   
   int   i = 0;//Rectangle counter 
   color    InfoColor = MidnightBlue;
   while ( i < 2) {//Draw a rectangle background so the info shows better
      ObjectCreate   ("RecIa"+i, OBJ_LABEL, 0, 0, 0);
      ObjectSetText  ("RecIa"+i,"g",48, "Webdings", InfoColor);
      ObjectSet      ("RecIa"+i, OBJPROP_CORNER,0);
      ObjectSet      ("RecIa"+i, OBJPROP_XDISTANCE,(50*i));
      ObjectSet      ("RecIa"+i, OBJPROP_YDISTANCE,12); 
      ObjectSet      ("RecIa"+i, OBJPROP_BACK,false); 
       ObjectCreate   ("RecIb"+i, OBJ_LABEL, 0, 0, 0);
       ObjectSetText  ("RecIb"+i,"g",48, "Webdings", InfoColor);
       ObjectSet      ("RecIb"+i, OBJPROP_CORNER,0);
       ObjectSet      ("RecIb"+i, OBJPROP_XDISTANCE,(50*i));
       ObjectSet      ("RecIb"+i, OBJPROP_YDISTANCE,65); 
       ObjectSet      ("RecIb"+i, OBJPROP_BACK,false); 
      i++;} 
   //-------------     
   double   spread = MarketInfo(Symbol(),MODE_SPREAD)/SymbolPointMul;
   string   leverage =  DoubleToStr(AccountLeverage(),0);
   string   Spread = DoubleToStr(spread,1);
   string   Slim   = DoubleToStr(MaxSpread,1);
   string   account;
   double   CAR = CapitalAtRisk();//Calculate the loss if all open order goes to StopLoss
   string   CapitalAtRisk = DoubleToStr(CAR,1);//Format to 1 decimal
   if(IsDemo())  account = "DEMO";
   if(!IsDemo()) account = "LIVE";
   string   SDmessage = "";
   if(InfoSDmessage) {//The EA has stopped trading due to excessive losses !
      SDmessage = StringConcatenate(""
      + "####  IN ORDER TO PROTECT THE ACCOUNT ", WindowExpertName()," HAS STOPPED TRADING ON ", Symbol(),"  ####");
      color    WarnColor = Red; i = 0;
      //Print(SDmessage);
      while ( i < 18) {//Draw a rectangle background for warning message:   
         ObjectCreate   ("RecW"+i, OBJ_LABEL, 0, 0, 0);
         ObjectSetText  ("RecW"+i,"g",26, "Webdings", WarnColor);
         ObjectSet      ("RecW"+i, OBJPROP_CORNER,0);
         ObjectSet      ("RecW"+i, OBJPROP_XDISTANCE,(33*i));
         ObjectSet      ("RecW"+i, OBJPROP_YDISTANCE,133); 
         ObjectSet      ("RecW"+i, OBJPROP_BACK,false); 
         i++;}
      //-------------
      }   
   Comment(""
            + "Trading Time:     ", StartTime, " - ",StopTime
            + "\n"
            + "Current spread:   ", Spread
            + "\n"
            + "Spread Limit:      ",Slim
            + "\n"
            + "Account:            ", account
            + "\n"
            + "Leverage:          1: ",leverage
            + "\n"
            + "Captital at risk:   $", CapitalAtRisk
            + "\n"
            + "--"//Future Use
            + "\n"
            + "--"//Future Use
            + "\n"
            + "Magic Number:   ",MagicNumber//Do Not Change Below Here !
            + "\n"
            + "-----------------------------------"
            + "\n"
            + "\n"           
            + SDmessage
            + "");
return (0);
}
//-----------------------------------------------------

//---------------- DeleteInfoBackground -------------------------
void DeleteInfoBackground() {
   int ObjectsAll = ObjectsTotal();
   int   i = 0;
   while(i < ObjectsAll) {
      ObjectDelete("RecIa"+i);//Background for the InfoField
      ObjectDelete("RecIb"+i);//Background for the InfoField      
      ObjectDelete("RecW"+i);//Background for the WarningField     
      i++;
      }
return (0);
}
//-----------------------------------------------------

//---------------- AutoMagic --------------------------
void AutoMagic() {
   if( !AutoMagic ) return(0);//Magic Number will be set manually
   //AutoMagicNumbers has the format: 9999XXY
   string   MagAutoApp = "00";//MagicAutoAppendage   
   if(Symbol() == "EURUSD"){
      MagAutoApp = "01";// !! "00" is reserved for Symbol not found !!
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "USDCHF"){
      MagAutoApp = "02";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "USDJPY"){
      MagAutoApp = "03";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "GBPUSD"){
      MagAutoApp = "04";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "AUDUSD"){
      MagAutoApp = "05";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "USDCAD"){
      MagAutoApp = "06";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "EURGBP"){
      MagAutoApp = "07";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "EURCHF"){
      MagAutoApp = "08";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "EURJPY"){
      MagAutoApp = "09";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "GBPJPY"){
      MagAutoApp = "10";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "GBPCHF"){
      MagAutoApp = "11";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "EURCAD"){
      MagAutoApp = "12";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "EURAUD"){
      MagAutoApp = "13";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "USDSGD"){
      MagAutoApp = "14";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "NZDUSD"){
      MagAutoApp = "15";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "CHFJPY"){
      MagAutoApp = "16";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "EURNZD"){
      MagAutoApp = "17";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "AUDJPY"){
      MagAutoApp = "18";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "AUDNZD"){
      MagAutoApp = "19";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "AUDCAD"){
      MagAutoApp = "20";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "AUDCHF"){
      MagAutoApp = "21";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "CADCHF"){
      MagAutoApp = "22";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "CADJPY"){
      MagAutoApp = "23";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "NZDJPY"){
      MagAutoApp = "24";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "USDDKK"){
      MagAutoApp = "25";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "USDNOK"){
      MagAutoApp = "26";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "USDSEK"){
      MagAutoApp = "27";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "USDHKD"){
      MagAutoApp = "28";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "SGDJPY"){
      MagAutoApp = "29";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
      
   if(MagAutoApp == "00" ) {//Symbol not found
      //------------------- Magic Warning Message -----------------------------------------------------------------------
      int   ButtonClicked = MessageBox("Could not generate Automatic MagicNumber for Symbol " + Symbol()
                           +"\n"+"reverting to default MagicNumber."
                           +"\n"+"You MUST disable AutoMagic, and set MagicNumber manually !"
                           +"\n"+""
                           +"\n"+"  ", "CAUTION !          " + Symbol(), MB_OK|MB_ICONEXCLAMATION);
      //-----------------------------------------------------------------------------------------------------------------
      return(0);
      }
MagicNumber = StrToInteger("9999"+MagAutoApp);//AutoMagicNumbers has the format: 9999XXY
return (0);
}
//-----------------------------------------------------

//---------------- MagicWarning -----------------------
void MagicWarning() {
   if(   (MagicNumber != MagicNumber_Old) 
         || (AutoMagic != AutoMagic_Old)
         || (TradeLong != TradeLong_Old)
         || (TradeShort != TradeShort_Old)  )   
      {//Changes were made that could result in a new MagicNumber...      
      //------------------- Magic Warning Message -----------------------------------------------------------------------
      int   ButtonClicked = MessageBox("Changing the MagicNumber or AutoMagic parameters, or changing the TradeLong or TradeShort " 
                           +"\n"+"parameters while AutoMagic is enabled, WILL result in a new MagicNumber !"
                           +"\n"+"All open orders WILL become orphan orders, and will have to be dealt with manually !!"
                           +"\n"+""
                           +"\n"+"  ", "CAUTION !          " + Symbol(), MB_OK|MB_ICONEXCLAMATION);
      //-----------------------------------------------------------------------------------------------------------------
      }   
   //Update the references:
   MagicNumber_Old = MagicNumber;
   AutoMagic_Old = AutoMagic;
   TradeLong_Old = TradeLong;
   TradeShort_Old = TradeShort;
return (0);
}
//-----------------------------------------------------


//---------------- SaveAccount ------------------------
bool  SaveAccount() {
   //If account balance drops below limit no new orders wil be opened, 
   //but any orders already open will be handled normaly.
   //After a Save Account event the EA can be unlocked by changing to a different TF and back
   if(OneShot) return(TRUE);
   int Balance = AccountBalance();   
   if( Balance < BalanceCutOff ) {
   InfoSDmessage = TRUE;//Flag for InfoField
   string body = StringConcatenate( TimeToStr((TimeCurrent()) ), " :  ", "In order to protect the account ", 
   WindowExpertName()," has stopped trading.", "    ShutDown Limit: ", BalanceCutOff, "    Current Balance: ", Balance        );
   //Alert(body);
   //Print(body);
   SendMail(WindowExpertName() + " has stopped trading.", body);
   //ErrorLog();//check for errors   
   OneShot = TRUE;
   return (TRUE); }   
return (FALSE);
}
//-----------------------------------------------------


//---------------- Authenticate -----------------------
bool  Authenticate() {
   int   AuthorizedAccountNumber0 = 700657;//Authorized Primary account
   int   AuthorizedAccountNumber1 = 756719;//Authorized Demo1 account
   int   AuthorizedAccountNumber2 = 999999;//Authorized Demo2 account         
   if(AccountNumber() == AuthorizedAccountNumber0 ) return (TRUE);
   if(AccountNumber() == AuthorizedAccountNumber1 ) return (TRUE);
   if(AccountNumber() == AuthorizedAccountNumber2 ) return (TRUE);
   Alert("This EA is not authorized and this is a STOLEN copy!");
   string x = "SSNPN26126543580";  
return (FALSE);
}
//-----------------------------------------------------------------------

//---------------- ErrorLog ---------------------------
void ErrorLog() {
   int      code = GetLastError() ;
   if( (code == 0) || (code == 4000) ) return(0);//no errors
   string   msg = StringConcatenate("                                          << ERROR: >>    Code: ",code,"   ",ErrorDescription(code));
   Print(msg);
return (0);
}
//-----------------------------------------------------
//-----------------------------------------------------------
void DrawVline (color Color, datetime time)
{
ObjCnt++;
ObjectCreate( "UpLine"+ObjCnt, OBJ_VLINE, 0, time, 0);
ObjectSet("UpLine"+ObjCnt, OBJPROP_COLOR, Color);
ObjectSet("UpLine"+ObjCnt, OBJPROP_BACK,true);
return(0);
}     
//-----------------------------------------------------------    